// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUICommand;
import org.apache.myfaces.tobago.layout.Display;
import org.apache.myfaces.tobago.layout.Measure;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders a command inside of a tree.
  * UIComponent class, generated from template {@code component2.0.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.TreeCommandTagDeclaration}.
 */
public class UITreeCommand
    extends AbstractUICommand implements SupportsMarkup {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.TreeCommand";

  public static final String COMPONENT_FAMILY = "javax.faces.Command";

  private org.apache.myfaces.tobago.context.Markup currentMarkup;

  enum PropertyKeys {
    markup,
    marginLeft,
    link,
    tabIndex,
    minimumHeight,
    tip,
    height,
    minimumWidth,
    inline,
    rowSpan,
    left,
    columnSpan,
    top,
    maximumHeight,
    currentWidth,
    marginTop,
    width,
    marginRight,
    preferredHeight,
    jsfResource,
    resource,
    currentHeight,
    transition,
    display,
    label,
    maximumWidth,
    preferredWidth,
    marginBottom,
    verticalIndex,
    omit,
    renderedPartially,
    target,
    onclick,
    horizontalIndex,
    disabled,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginLeft() {
    Object object = getStateHelper().eval(PropertyKeys.marginLeft);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginLeft(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginLeft(org.apache.myfaces.tobago.layout.Measure marginLeft) {
    getStateHelper().put(PropertyKeys.marginLeft, marginLeft);
  }

  /**
  Link to an arbitrary URL, either an internal link or an external link.

   <dl>
     <dt>internal absolute link</dt>
     <dd>Starts with a slash '/' character. The context path will be added.
         A session id will be added, if needed.</dd>
     <dt>external link</dt>
     <dd>Starts with protocol followed by a colon ':' character.
         The link will not be modified.</dd>
     <dt>internal relative link</dt>
     <dd>Any other strings. A session id will be added, if needed.</dd>
   </dl>

  */
  public java.lang.String getLink() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.link);
  }

  public void setLink(java.lang.String link) {
    getStateHelper().put(PropertyKeys.link, link);
  }

  /**
  Controls the navigation of the focus through the
   input controls on a page with the Tab-Key.
   The navigation starts from the element with
   the lowest tabIndex value to the element with the highest value.
   Elements that have identical tabIndex values should be navigated
   in the order they appear in the character stream
   Elements that are disabled or with a negative tabIndex
   do not participate in the tabbing order.

  */
  public java.lang.Integer getTabIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.tabIndex);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setTabIndex(java.lang.Integer tabIndex) {
    getStateHelper().put(PropertyKeys.tabIndex, tabIndex);
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumHeight() {
    Object object = getStateHelper().eval(PropertyKeys.minimumHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMinimumHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMinimumHeight(org.apache.myfaces.tobago.layout.Measure minimumHeight) {
    getStateHelper().put(PropertyKeys.minimumHeight, minimumHeight);
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.tip);
  }

  public void setTip(java.lang.String tip) {
    getStateHelper().put(PropertyKeys.tip, tip);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getHeight() {
    Object object = getStateHelper().eval(PropertyKeys.height);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setHeight(org.apache.myfaces.tobago.layout.Measure height) {
    getStateHelper().put(PropertyKeys.height, height);
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumWidth() {
    Object object = getStateHelper().eval(PropertyKeys.minimumWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMinimumWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMinimumWidth(org.apache.myfaces.tobago.layout.Measure minimumWidth) {
    getStateHelper().put(PropertyKeys.minimumWidth, minimumWidth);
  }

  /**
  Flag indicating this component should rendered as an inline element.
  <br />Default: <code>false</code>
  @deprecated*/
  @Deprecated
  public boolean isInline() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.inline);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  @Deprecated
  public void setInline(boolean inline) {
      Deprecation.LOG.error("The attribute 'inline' of 'UITreeCommand' is deprecated. "
          + "Please refer the documentation for further information.");
    getStateHelper().put(PropertyKeys.inline, inline);
  }

  public java.lang.Integer getRowSpan() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.rowSpan);
    if (value != null) {
      return value.intValue();
    }
    return 1;
  }

  public void setRowSpan(java.lang.Integer rowSpan) {
    getStateHelper().put(PropertyKeys.rowSpan, rowSpan);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getLeft() {
    Object object = getStateHelper().eval(PropertyKeys.left);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return null;
  }

  public void setLeft(org.apache.myfaces.tobago.layout.Measure left) {
    getStateHelper().put(PropertyKeys.left, left);
  }

  public java.lang.Integer getColumnSpan() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.columnSpan);
    if (value != null) {
      return value.intValue();
    }
    return 1;
  }

  public void setColumnSpan(java.lang.Integer columnSpan) {
    getStateHelper().put(PropertyKeys.columnSpan, columnSpan);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getTop() {
    Object object = getStateHelper().eval(PropertyKeys.top);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return null;
  }

  public void setTop(org.apache.myfaces.tobago.layout.Measure top) {
    getStateHelper().put(PropertyKeys.top, top);
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumHeight() {
    Object object = getStateHelper().eval(PropertyKeys.maximumHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMaximumHeight(org.apache.myfaces.tobago.layout.Measure maximumHeight) {
    getStateHelper().put(PropertyKeys.maximumHeight, maximumHeight);
  }

  /**
  This value will usually be set by the layout manager. It holds the current width computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentWidth() {
    Object object = getStateHelper().eval(PropertyKeys.currentWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getWidth();
  }

  public void setCurrentWidth(org.apache.myfaces.tobago.layout.Measure currentWidth) {
    getStateHelper().put(PropertyKeys.currentWidth, currentWidth);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginTop() {
    Object object = getStateHelper().eval(PropertyKeys.marginTop);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginTop(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginTop(org.apache.myfaces.tobago.layout.Measure marginTop) {
    getStateHelper().put(PropertyKeys.marginTop, marginTop);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getWidth() {
    Object object = getStateHelper().eval(PropertyKeys.width);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setWidth(org.apache.myfaces.tobago.layout.Measure width) {
    getStateHelper().put(PropertyKeys.width, width);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginRight() {
    Object object = getStateHelper().eval(PropertyKeys.marginRight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginRight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginRight(org.apache.myfaces.tobago.layout.Measure marginRight) {
    getStateHelper().put(PropertyKeys.marginRight, marginRight);
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredHeight() {
    Object object = getStateHelper().eval(PropertyKeys.preferredHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPreferredHeight(org.apache.myfaces.tobago.layout.Measure preferredHeight) {
    getStateHelper().put(PropertyKeys.preferredHeight, preferredHeight);
  }

  /**
  Flag indicating that the resource referenced by the resource attribute is a jsf resource.
   That means that the url has to be processed to change the prefix or suffix (e. g. *.jsf or
   /faces/*). Default is false.
  <br />Default: <code>false</code>
  */
  public boolean isJsfResource() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.jsfResource);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setJsfResource(boolean jsfResource) {
    getStateHelper().put(PropertyKeys.jsfResource, jsfResource);
  }

  /**
  Link to an internal resource.
   Resources will be processed by the resource management.
   E. g. define help.html and it will be served help_es.html or help_de.html if available.
   For JSF-Pages you have to set the jsfResource attribute.

  */
  public java.lang.String getResource() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.resource);
  }

  public void setResource(java.lang.String resource) {
    getStateHelper().put(PropertyKeys.resource, resource);
  }

  /**
  This value will usually be set by the layout manager. It holds the current height computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentHeight() {
    Object object = getStateHelper().eval(PropertyKeys.currentHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getHeight();
  }

  public void setCurrentHeight(org.apache.myfaces.tobago.layout.Measure currentHeight) {
    getStateHelper().put(PropertyKeys.currentHeight, currentHeight);
  }

  /**
  Specify, if the command calls an JSF-Action.
   Useful to switch off the Double-Submit-Check and Waiting-Behavior.
  <br />Default: <code>true</code>
  */
  public boolean isTransition() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.transition);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setTransition(boolean transition) {
    getStateHelper().put(PropertyKeys.transition, transition);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Display getDisplay() {
    return (org.apache.myfaces.tobago.layout.Display) getStateHelper().eval(PropertyKeys.display);
  }

  public void setDisplay(org.apache.myfaces.tobago.layout.Display display) {
    getStateHelper().put(PropertyKeys.display, display);
  }

  /**
  Text value to display as label.
   If text contains an underscore the next character is used as accesskey.

  */
  public java.lang.String getLabel() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.label);
  }

  public void setLabel(java.lang.String label) {
    getStateHelper().put(PropertyKeys.label, label);
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumWidth() {
    Object object = getStateHelper().eval(PropertyKeys.maximumWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMaximumWidth(org.apache.myfaces.tobago.layout.Measure maximumWidth) {
    getStateHelper().put(PropertyKeys.maximumWidth, maximumWidth);
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredWidth() {
    Object object = getStateHelper().eval(PropertyKeys.preferredWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPreferredWidth(org.apache.myfaces.tobago.layout.Measure preferredWidth) {
    getStateHelper().put(PropertyKeys.preferredWidth, preferredWidth);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginBottom() {
    Object object = getStateHelper().eval(PropertyKeys.marginBottom);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginBottom(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginBottom(org.apache.myfaces.tobago.layout.Measure marginBottom) {
    getStateHelper().put(PropertyKeys.marginBottom, marginBottom);
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getVerticalIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.verticalIndex);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setVerticalIndex(java.lang.Integer verticalIndex) {
    getStateHelper().put(PropertyKeys.verticalIndex, verticalIndex);
  }

  /**
  Flag indicating that the action of this element, will not be executed from client side
   (e. g. when the user clicks a button.
   When setting this value to true, the action will not be executed by the Tobago, but it can executed
   by JavaScript.
   This attribute is useful, when you want to add JavaScript event handlers to commands manually.
   In this case you usually don't want a submit with a full reload of the page.
  <br />Default: <code>false</code>
  */
  public boolean isOmit() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.omit);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setOmit(boolean omit) {
    getStateHelper().put(PropertyKeys.omit, omit);
  }

  /**
  Indicate the partially rendered Components in a case of a submit.

  */
  public String[] getRenderedPartially() {
    Object strArray = getStateHelper().eval(PropertyKeys.renderedPartially);
    if (strArray != null) {
      if (strArray instanceof String[]) {
        return (String[]) strArray;
      } else if (strArray instanceof String) {
        String[] strings = StringUtils.split((String) strArray, ", ");
        List<String> result = new ArrayList<String>(strings.length);
        for (String string : strings) {
          if (string.trim().length() != 0) {
            result.add(string.trim());
          }
        }
        return result.toArray(new String[result.size()]);
      } else if (strArray == null) {
        return org.apache.myfaces.tobago.internal.util.ArrayUtils.EMPTY_STRING_ARRAY;
      } else {
        return new String[]{strArray.toString()};
      }
    }
    return org.apache.myfaces.tobago.internal.util.ArrayUtils.EMPTY_STRING_ARRAY;
  }

  public void setRenderedPartially(String[] renderedPartially) {
    getStateHelper().put(PropertyKeys.renderedPartially, renderedPartially);
  }

  /**
  Name of a frame where the resource retrieved via this hyperlink is to be
   displayed.

  */
  public java.lang.String getTarget() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.target);
  }

  public void setTarget(java.lang.String target) {
    getStateHelper().put(PropertyKeys.target, target);
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  /**
  Script to be invoked when clicked

  */
  public java.lang.String getOnclick() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.onclick);
  }

  public void setOnclick(java.lang.String onclick) {
    getStateHelper().put(PropertyKeys.onclick, onclick);
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getHorizontalIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.horizontalIndex);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setHorizontalIndex(java.lang.Integer horizontalIndex) {
    getStateHelper().put(PropertyKeys.horizontalIndex, horizontalIndex);
  }

  /**
  Flag indicating that this element is disabled.
  <br />Default: <code>false</code>
  */
  public boolean isDisabled() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.disabled);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setDisabled(boolean disabled) {
    getStateHelper().put(PropertyKeys.disabled, disabled);
  }

  public Object saveState(FacesContext context) {
    currentMarkup = null;
    return super.saveState(context);
  }

}